/*******************************************************************************
 *
 * hyper-channel: implements CPU side-channel based hypervisor detection.
 *
 * Uses RSB side-channel spy that puts Return Stack Buffer (RSB) structure in a known state
 * and monitors its possible corruption by a hyperviser during VMExit.
 *
 * For educational purposes only. Use it on your onw risk.
 *
 * 04/19/2008 c7zero@c7zero.info
 *
 ******************************************************************************/

#ifndef __BSR_H
#define __BSR_H

#include <ntddk.h>

#define _PERFMON

#define __RDTSC( cyc_hi, cyc_lo ) __asm \
		  {                                 \
			__asm push eax                    \
			__asm push edx                    \
			__asm rdtsc                       \
			__asm mov [cyc_lo], eax           \
			__asm mov [cyc_hi], edx           \
			__asm pop edx                     \
			__asm pop eax                     \
		  }

#define __DURATION( cyc2_hi, cyc2_lo, cyc1_hi, cyc1_lo ) \
  ( (((unsigned __int64)cyc2_hi << 32) | cyc2_lo) - (((unsigned __int64)cyc1_hi << 32) | cyc1_lo) )


#define DEVICE_NAME     L"\\device\\bsr"
#define DOS_DEVICE_NAME L"\\dosdevices\\bsr"

#define FILE_DEVICE_BSR 32771

#define IOCTL_BUFFIO_RSB_DETECT \
        CTL_CODE( FILE_DEVICE_BSR, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define _THRESHOLD_DEFAULT 100
#define _MEASURMENTS_COUNT 1000000


#endif // __BSR_H
